<?php

/**
 * co_carac_contratista actions.
 *
 * @package    contratacion
 * @subpackage co_carac_contratista
 * @author     ManuelEnriqueParedesLopez
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class co_carac_contratistaActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CO_CARAC_CONTRATISTA_V',
        'CO_CONTRATISTA',
        'CO_NAT_JUR',
        'CO_TIPO_IDEN'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CO_CONTRATISTA,LEFT' =>
        array(
            'id_contratista' => 'CO_CARAC_CONTRATISTA_V'
        ),
        'CO_NAT_JUR,LEFT' =>
        array(
            'id_nat_jur' => 'CO_CONTRATISTA'
        ),
        'CO_TIPO_IDEN,LEFT' =>
        array(
            'id_tipo_iden' => 'CO_CONTRATISTA'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CO_CARAC_CONTRATISTA_V' =>
        array(
            'id_carac_contratista' => 'id_carac_contratista',
            'id_contratista' => 'id_contratista',
            'genero' => 'genero',
            'edad' => 'edad',
            'hijos' => 'hijos',
            'id_hobbie' => 'id_hobbie',
            'id_medio_transporte' => 'id_medio_transporte',
            'id_deporte' => 'id_deporte',
            'id_academico_b' => 'id_academico_b',
            'id_academico_u' => 'id_academico_u',
            'id_idioma' => 'id_idioma',
            'id_estado_civil' => 'id_estado_civil',
            'genero_text' => 'genero_text',
            'descripcion_deporte' => 'descripcion_deporte',
            'descripcion_hobbie' => 'descripcion_hobbie',
            'descripcion_medio_trans' => 'descripcion_medio_trans',
            'descripcion_estado_civil' => 'descripcion_estado_civil',
            'descripcion_idioma' => 'descripcion_idioma',
            'descripcion_academico_b' => 'descripcion_academico_b',
            'descripcion_academico_u' => 'descripcion_academico_u'
        ),
        'CO_CONTRATISTA' =>
        array(
            'id_contratista' => 'id_contratista_cont',
            'id_nat_jur' => 'id_nat_jur',
            'id_tipo_iden' => 'id_tipo_iden',
            'num_doc' => 'num_doc',
            'dv' => 'dv',
            'nombre_razon' => 'nombre_razon',
            'telefono' => 'telefono',
            'celular' => 'celular',
            'direccion' => 'direccion',
            'email' => 'email',
            'representante_legal' => 'representante_legal',
            'ciudad' => 'ciudad',
            'num_doc,||, - ,||,nombre_razon' => 'completo',
            'factor_rh' => 'factor_rh',
            'fecha_nacimiento' => 'fecha_nacimiento',
            'ciudad_nacimiento' => 'ciudad_nacimiento',
            'id_tipo_regimen' => 'id_tipo_regimen',
            'num_doc_rep_leg' => 'num_doc_rep_leg'
        ),
        'CO_NAT_JUR' =>
        array(
            'descripcion' => 'naturaleza'
        ),
        'CO_TIPO_IDEN' =>
        array(
            'descripcion' => 'tipo_iden'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
        'id_carac_contratista'
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CO_CARAC_CONTRATISTA_V' =>
        array(
            'id_carac_contratista,a' => array('!=' => array(-1)),
            'id_carac_contratista,b' => array('=' => array('id_carac_contratista')),
            'id_contratista' => array('=' => array('id_contratista')),
            'hijos' => array('=' => array('hijos')),
            'genero' => array('=' => array('genero')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//   protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;

    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_carac_contratista'; //identificador de la tabla
    protected $id_names = array('id_carac_contratista'); //llave primaria
    protected $field_names = array('id_contratista', 'genero', 'edad', 'hijos',
        'id_hobbie', 'id_medio_transporte', 'id_deporte',
        'id_academico_b', 'id_academico_u', 'id_idioma', 'id_estado_civil'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CO_CARAC_CONTRATISTA'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_carac_contratista'; //identificador unico de la tabla

    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            $id_contratista = $request['id_contratista'];

            $sql = <<<EOD
                      
                      SELECT 
       tab0.ID_CONTRATISTA,
       tab0.ID_NAT_JUR,
       tab0.ID_TIPO_IDEN,
       tab0.NUM_DOC,
       tab0.DV,
       tab0.NOMBRE_RAZON,
       tab0.TELEFONO,
       tab0.CELULAR,
       tab0.DIRECCION,
       tab0.EMAIL,
       tab0.REPRESENTANTE_LEGAL,
       tab0.CIUDAD,
       tab0.FACTOR_RH,
       to_char(tab0.FECHA_NACIMIENTO,'dd-mm-yyyy') as fecha_nacimiento,
       tab0.CIUDAD_NACIMIENTO,
       tab0.ID_TIPO_REGIMEN,
       tab0.NUM_DOC_REP_LEG
FROM CO_CONTRATISTA tab0   
WHERE 1=1 AND tab0.id_contratista=$id_contratista                      
EOD;

            $records = CN_TABLE::executeSQL($sql);

            $dateOfBirth = $records[0]['fecha_nacimiento'];
            $today = date("Y-m-d");
            $diff = date_diff(date_create($dateOfBirth), date_create($today));
            $age = $diff->format('%y');

            $request['edad'] = $age;
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         * Variables request
         */
        $id_contratista = $request['id_contratista'];

        /*
         *  Validar la operación, ya sea por SQL
         */
        $sql = <<<EOD
SELECT
    *
FROM co_carac_contratista

where
id_contratista = $id_contratista  
EOD;
        $records = CN_TABLE::executeSQL($sql);
        /*
         *  Generar errores en $errors
         */
        if (count($records) > 0) {
            $errors['mensaje'] = "El contratista ya posee un registro de caracterización.";
            $errors['servicio'] = "co_carac_contratista";
        }

        return $errors;
    }

    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

}
